$JOB           I/O DEFINITIONS
$EXECUTE       IBSFAP
$ID            IODEF
* M1416 3845  PETER R. BOS ..... FILE SYSTEM ENTRIES FOR BACKGROUND .....
*      FAP
       PCC     ON 
*      BCORE
*      NOLNK
*      ENTRY   SETIO         DUMMY ENTRY TO INITIALIZE FILE SYSTEM
*      ENTRY   GETIME        GET DATE AND TIME OF DAY 
*      ENTRY   TPWAIT        WAIT ON TAPE CHANNELS    
*      ENTRY   FERRTN        SET UP FILE ERROR RETURN 
*      ENTRY   TILOCK        SET UP FILE INTERLOCK RETURN   
*      ENTRY   EXIT          EXIT TO FMS OR STOP
*      ENTRY   PRINT         PRINT ON ON-LINE PRINTER 
*      ENTRY   PUNCH         PUNCH CARD ONLINE  
*      ENTRY   EPRINT        PRINT ONLINE DISABLED    
*      ENTRY   WRFLX         TYPE ON TYPEWRITER (FOR COMPATIBILITY)     
       REM
       ENTRY   UPDMFD        ENTRIES TO CTSS FILE COORDINATOR     
       ENTRY   DELMFD        ..     
       ENTRY   ATTACH        ..     
       ENTRY   ATTNAM        ..     
       ENTRY   UPDATE        ..     
       ENTRY   SETPRI        ..     
       ENTRY   OPEN          ..     
       ENTRY   BUFFER        ..     
       ENTRY   RDFILE        ..     
       ENTRY   RDWAIT        ..     
       ENTRY   WRFILE        ..     
       ENTRY   WRWAIT        ..     
       ENTRY   TRFILE        ..     
       ENTRY   FCHECK        ..     
       ENTRY   FWAIT         ..     
       ENTRY   CLOSE         ..     
       ENTRY   RESETF        ..     
       ENTRY   CHFILE        ..     
       ENTRY   DELFIL        ..     
       ENTRY   FSTATE        ..     
       ENTRY   MOVFIL        ..     
       ENTRY   SETFIL        ..     
       ENTRY   LINK          ..     
       ENTRY   UNLINK        ..     
       ENTRY   ALLOT         ..     
       ENTRY   STORGE        ..     
       ENTRY   MOUNT         ..     
       ENTRY   UMOUNT        ..     
       ENTRY   VERIFY        ..     
       ENTRY   LABEL         ..     
       ENTRY   TAPFIL        ..     
       ENTRY   IODIAG        ..     
       LBL     IODEF     
       PCC     OFF
       REM
       REM
SETIO  TRA     2,4           DUMMY INITIALIZE ENTRY   
       REM
GETIME TIA     =HGETIME      ..     
TPWAIT SXA     TPX1,1        WAIT ON TAPE CHANNELS    
       CAL     1,4           CHANNEL NUMBER     
       PAC     ,1            ..     
       TXL     OOPS,1,-3     BAD CHANNEL NO.    
BACK   XEC     TCO,1         WAIT FOR I/O COMPLETION  
       XEC     TRC,1         CHECK FOR REDUNDANCY     
       XEC     TEF,1         CHECK FOR EOF
OOPS   TXI     *+1,4,-4      NORMAL RETURN 4,4  
TPX1   AXT     -,1           RESTORE X1   
       TRA     0,4           EXIT   
TCO    SYN     *-1           TABLE OF TCOX INST.
       TCOA    BACK          ..     
       TCOB    BACK          ..     
TRC    SYN     *-1           TABLE OF TRCX
       TRCA    ERR           ..     
       TRCB    ERR           ..     
TEF    SYN     *-1           TABLE OF TEFX
       TEFA    EOF           ..     
       TEFB    EOF           ..     
ERR    TXI     TPX1,4,-2     TAPE CHECK RETURN 2,4    
EOF    TXI     TPX1,4,-3     EOF RETURN 3,4     
       REM
FERRTN TIA     =HFERRTN      ..     
TILOCK TIA     =HTILOCK      ..     
EXIT   TIA     =HDEAD        ..     
PRINT  TIA     =HPRINT       ..     
PUNCH  TIA     =HPUNCH       ..     
EPRINT TIA     =HPRINT       ..     
WRFLX  TIA     =HWRFLX       ..     
       REM
UPDMFD TIA     =HUPDMFD      FILE COORDINATOR ENTRIES 
DELMFD TIA     =HDELMFD      ..     
ATTACH TIA     =HATTACH      ..     
ATTNAM TIA     =HATTNAM      ..     
UPDATE TIA     =HUPDATE      ..     
SETPRI TIA     =HSETPRI      ..     
OPEN   TIA     =HOPEN        ..     
BUFFER TIA     =HBUFFER      ..     
RDFILE TIA     =HRDFILE      ..     
RDWAIT TIA     =HRDWAIT      ..     
WRFILE TIA     =HWRFILE      ..     
WRWAIT TIA     =HWRWAIT      ..     
TRFILE TIA     =HTRFILE      ..     
FCHECK TIA     =HFCHECK      ..     
FWAIT  TIA     =HFWAIT       ..     
CLOSE  TIA     =HCLOSE       ..     
RESETF TIA     =HRESETF      ..     
CHFILE TIA     =HCHFILE      ..     
DELFIL TIA     =HDELFIL      ..     
FSTATE TIA     =HFSTATE      ..     
MOVFIL TIA     =HMOVFIL      ..     
SETFIL TIA     =HSETFIL      ..     
LINK   TIA     =HLINK        ..     
UNLINK TIA     =HUNLINK      ..     
ALLOT  TIA     =HALLOT       ..     
STORGE TIA     =HSTORGE      ..     
MOUNT  TIA     =HMOUNT       ..     
UMOUNT TIA     =HUMOUNT      ..     
VERIFY TIA     =HVERIFY      ..     
LABEL  TIA     =HLABEL       ..     
TAPFIL TIA     =HTAPFIL      ..     
IODIAG TIA     =HIODIAG      ..     
       REM
       RMT     *  
       END  
